<template>
    <div>
        <div class="wrap">
            <ul class="nav nav-pills navigation">
                <li class="nav-item">
                    <router-link class="nav-link" to="/" v-if="loggedIn" exact>Home</router-link>
                </li>
                <li class="nav-item">
                    <router-link class="nav-link" to="/admin" v-if="loggedIn && isAdmin" exact>Admin</router-link>
                </li>
                <li class="nav-item">
                    <router-link class="nav-link" to="/add-listing" v-if="loggedIn" exact>Add Listing</router-link>
                </li>
                <li class="nav-item">
                    <router-link class="nav-link" v-if="loggedIn" to="/cart" exact>Cart</router-link>
                </li>
                <li class="nav-item">
                    <router-link v-if="!loggedIn" class="nav-link" to="/register" exact>Register</router-link>
                </li>
                <li class="nav-item">
                    <router-link v-if="!loggedIn" class="nav-link" to="/login" exact>Login</router-link>
                </li>
                <li class="nav-item">
                    <a href="/" v-if="loggedIn" class="nav-link" @click.prevent="logout">Logout</a>
                </li>
            </ul>

            <button type="button" v-if="loggedIn" class="btn btn-warning user">{{userName}}</button>
            <button type="button" class="btn btn-secondary goright" v-bind:class="{ 'btn-success': cartCount !== 0 }"
                    @mouseover="mouseOver()" @mouseleave="mouseLeave()" @click.prevent="toCart"
                    v-if="(this.$route.path !=='/cart')&&loggedIn" @focusout="mouseLeave()">
                {{cartText()}}
            </button>

        </div>
        <hr class="mt-3 mb-3"/>
    </div>
</template>

<script>
    import {mapActions, mapGetters, mapState} from 'vuex'

    export default {
        name: "Header",
        data() {
            return {
                cartText: () => {
                    if (this.cartCount !== undefined) {
                        return `Cart: ${this.cartCount}`
                    }
                },
                //cartText: this.cartCount(),

            };
        },
        computed: {
            ...mapState({
                loggedIn: state => state.auth.loggedIn,
                isAdmin: state => state.auth.role === 'admin',
            }),
            ...mapGetters([
                'cartCount',
                'userName',
                'userRole',
                // ...
            ])
        },
        mounted() {
            this.$store.dispatch('getCart',).then(response => this.onSuccess(response)).catch(response => this.onError(response));
            //this.cartText()
        },
        methods: {
            toCart() {
                this.$router.push('/cart')
            },
            mouseOver() {
                this.cartText = () => 'Go To Cart';
            },
            mouseLeave() {
                this.cartText = () => `Cart: ${this.cartCount}`
            },
            ...mapActions(['logout']),
            onSuccess(response) {
                // console.log(response.data);
                this.$store.dispatch('setCart', response.data)
                // this.$store.dispatch('setCurrentPage', response.data.current_page)
                // this.$store.dispatch('setLastPage', response.data.last_page)
            },
            onError(response) {
                console.log(response)
            },


        }
    }
</script>

<style scoped>
    .navigation {
        height: 60px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        padding-left: 21px;
    }

    .nav-item {
        margin-left: 5px;
    }

    .wrap {
        display: flex;
        height: 60px;
        justify-content: space-between;
        align-items: center;
    }

    .user {
        margin-right: 150px;
    }

    .goright {
        align-items: center;
        margin-right: 21px;

    }
</style>
